Subject: RE: G9 requirement upon LDAP, not LDUP

From: Christopher Apple <[email-masked]>
Date: Wed, 11 Apr 2001 12:17:37 -0400

I think we could accomplish the same end you seem to be advocating
if we simply replace the word MUST with SHOULD in the original text.

That way, its still a requirement that a replication considerations
sections be there, but the SHOULD allows editors of new LDAP extension
I-Ds opt to not include one if there is a very good reason to do so.
One very good reason to *not* include such a section is that the LDUP
WG has not concluded its work. However, I can't conceive of any substantive
downside to simply including the section and stating whether or not LDAPv3
replication considerations were made during the creation of any such I-D.
So, I think most editors that behave in a way that you have agreed is
desirable (paying attention to X.500/LDAP considerations) would simply
include the 10 or so extra lines of text required to accommodate this
requirement.

My comments on your sample reactions to this sort of requirement are
below...

Chris Apple
Program Manager - Directory Services
United Messaging Inc.
http://www.unitedmessaging.com
[email-masked]
<mailto:[email-masked]> 
(V) 610-425-2860

> -----Original Message-----
> From: Kurt D. Zeilenga [mailto:[email-masked]]
> Sent: Tuesday, April 10, 2001 10:28 PM
> To: Richard Huber
> Cc: [email-masked]
> Subject: Re: G9 requirement upon LDAP, not LDUP
> 
> 
> [Cc list trimmed]
> 
> At 04:51 PM 4/9/01 -0400, Richard Huber wrote:
> >> This is not to say that designers of extensions should ignore
> >> such considerations.  Designers of extensions should consider all
> >> aspects of the LDAP/X.500 data and service models including
> >> replication.
> >>
> >So if your concern is with our proposed mechanism rather 
> than our goal, do
> >you see some other way we can address the issue?
> 
> Well, I think in the short term (from now to the time when an
> LDUP Standard Track specification), I think the best way to
> ensure that LDAP/X.500 data and service models issues are
> addressed if for concerned members of the IETF to do appropriate
> review of the documents as they are progressed though the IETF.
> 
> If the LDUP requirement were to actually mandate a "Replication
> Considerations" section, here are some samples which you will
> likely get:
> 
>   1) no section, the authors/review did not see the req't.
>   2) no section, the authors/review don't believe any section can
>       be provided which adds value.

For samples 1 & 2, I believe that during review of any I-D, several
folks would be inclined to comment that no such sections exist and
SHOULD, provided that the requirement is indeed present in an RFC.
And that's a key point related to this discussion I believe. Until
this requirement is published within an RFC, it carries no real
weight for anyone outside of the Editors and participants of the
LDUP WG. Which would lead me to believe that sample 3 is actually
quite useful. I certainly want to know as an LDAP implementer (product
or service) whether or not LDAP replication was considered during the
design of any particular extension. And while its true that I will
assume that such considerations have not been made if a replication
considerations section is not present. I'm much more comfortable,
speaking as an LDAP service implementer, not as co-chair, knowing
that explicitly. So I disagree with your assertion that sample 3
is not useful. I wouldn't make reference to LDUP still being
an active WG, but the message that LDAP replication was not considered
is useful to me.

>   3) section with:
>         "LDAP Replication was not considered as LDUP is a "work
>         in progress''."

I think that sample 4 is a useful introductory sentence for such
document sections. As a WG participant and LDAP service implementer,
I'd be inclined to comment that more text should be included to
explain any known limitations, constraints, etc., or a statement
that none are known to exist.

>   4) section with:
>        "This extension is designed to support LDAP replication
>        which is consistent with the LDAP/X.500 data and service
>         models."

When it comes to sample 5, I'm inclined to agree that this is
not all that useful as worded. However, to cover the
situation it seems to be covering, I'd say that until the
LDUP WG has concluded, it makes more sense to include a
replication considerations section in LDAP extension I-Ds
of the same form as sample 3.

>   5) section with:
>        "This extension is designed to support LDUP, ''a work in
>        progress'', as currently designed but may not support
>         LDUP as defined in future Standard Track documents."
> 
> None of these are particular useful.  Until LDUP matures,
> I don't see how any useful statement can actually be made.
> 
> The problem is that the requirement, as stated, attempts to
> mandate that all LDAP Standard Track specifications to express
> considerations for a ''work in a progress''.  This seems quite
> inappropriate to me.

You are correct. The present wording does mandate this. My proposed
re-wording makes it more, but not completely, optional. However,
I believe that replication considerations are important enough
that not including such sections should be justified by good
reasons in open discussion on a mailing list on a case-by-case
basis. "Good" is of course subjective, and that's something
that the collective IETF LDAP community should decide on
a case-by-case basis.

> 
> I would suggest instead of requiring the authors to document
> such considerations you just say:
>   Authors of LDAP extensions SHOULD consider replication
>   issues.
>  As LDAP Replication is currently a "work in progress",
>   authors SHOULD note that any I-Ds detailing this work may be
>   updated, replaced, or obsoleted by other documents at any 
>   time.

I don't see a need to point out that I-Ds should not be viewed
as definitive. There is boiler plate text to this effect that
is supposed to be included with every I-D written.

>  I-Ds MUST NOT be viewed as a definitive.
>   
> 
> 
> 
> As this is not a requirement upon LDUP, I would not enumerate
> it as such.  I would instead place in the Introduction.
>

I don't follow what you mean by the above statement.

Are you recommending that this text be included in every
LDAP extension draft?

Chris.

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Wed, 11 Apr 2001 10:56:33 -0700

At 12:17 PM 4/11/01 -0400, Christopher Apple wrote:
>LDUP WG.

I disagree here.  This is being published as an Informational RFC.
It will have weight upon the LDUP WG only because the LDUP charter
says that the approach used to produce LDUP will be driven by these
requirements.  WG/Individuals producing of other Standard Track LDAP
extensions have some obligations to consider the work of others,
I don't think such a requirement carries any real weight upon the
WG/Individuals.

I am quite concerned that such a requirement statement would lead to
appeals on future documents based not on technical issues, but based
upon compliance with an Informational RFC which they were not bound to
though some charter or other process mechanism.

>"Good" is of course subjective, and that's something

Yes!  I trust that the Internet Process will ensure that any
LDAP replication issues anyone might have will be addressed in
future Standard Track specifications.

>I don't follow what you mean by the above statement.

I was suggesting the alternative statement I offered be placed in
the Introduction of the LDUP Requirements I-D.

Kurt